<script lang="ts">
    import type downtimeType from "../../types/downtime"

    export let outages: Array<downtimeType>

    const humaiseDate = (date: string) => {
        const parsedDate = new Date(date)

        return `${`0${parsedDate.getHours()}`.slice(-2)}:${`0${parsedDate.getMinutes()}`.slice(-2)}`
    }
    const getDay = (outages: Array<downtimeType>) => {
        // To complex? Yes
        const date = new Date(new Date(outages[0].started_at).toDateString())

        return `${`0${date.getDate()}`.slice(-2)}.${`0${date.getMonth() + 1}`.slice(-2)}.${date.getFullYear()}`
    }
</script>

<div>
    {#if outages.length == 0}
        <h1>Keine Fehler</h1>
    {:else}
        {#each outages as outage}
            <figure>
                <aside>
                    <h2>{outage.error}</h2>
                    <h5>{outage.id}</h5>
                </aside>
                <span>{humaiseDate(outage.started_at)} - {humaiseDate(outage.ended_at)}</span>
            </figure>
        {/each}
        <h6>{getDay(outages)}</h6>
    {/if}
</div>

<style>
    h1 {
        font-weight: 500;
        text-align: center;
    }

    figure {
        margin: 0px;
        margin-bottom: 20px;

        display: grid;
        grid-template-columns: 1fr auto;
        align-items: center;
    }

    span {
        color: gray;
    }

    h2, h5, h6 {
        margin: 0px;
        font-weight: normal;
    }
    h2 {
        margin-top: 13px;
        font-weight: 500;
    }
    h5 {
        color: gray;
    }
    h6 {
        text-align: center;
    }
</style>